'use strict';

Object.defineProperty(exports, '__esModule', {
    value: true
});

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) subClass.__proto__ = superClass; }

var _stream = require('stream');

var _stream2 = _interopRequireDefault(_stream);

var _coreJsLibraryEs6Object = require('core-js/library/es6/object');

var _coreJsLibraryEs6Object2 = _interopRequireDefault(_coreJsLibraryEs6Object);

var _cleanCss = require('clean-css');

var _cleanCss2 = _interopRequireDefault(_cleanCss);

var Transformer = (function (_stream$Transform) {
    function Transformer(opts) {
        _classCallCheck(this, Transformer);

        _get(Object.getPrototypeOf(Transformer.prototype), 'constructor', this).call(this);

        this.input = '';

        this.processor = new _cleanCss2['default'](opts);
    }

    _inherits(Transformer, _stream$Transform);

    _createClass(Transformer, [{
        key: '_transform',
        value: function _transform(chunk, enc, next) {
            if (chunk !== null) {
                this.input += chunk;
            }
            next();
        }
    }, {
        key: '_flush',
        value: function _flush(done) {
            var _this = this;

            this.clean(this.input).then(function (res) {
                _this.push(res);
                done();
            })['catch'](function (err) {
                throw new Error(err);
            });
        }
    }, {
        key: 'clean',
        value: function clean(input) {
            var _this2 = this;

            return new Promise(function (resolve, reject) {
                resolve(_this2.processor.minify(input).styles);
            });
        }
    }]);

    return Transformer;
})(_stream2['default'].Transform);

exports['default'] = Transformer;
module.exports = exports['default'];